import numpy as np

Paths = ['TheHunt', 'Destruction', 'Erudition',
    'Harmony', 'Nihility', 'Preservation', 'Abundance']
CombatType = ['Physical', 'Wild', 'Ice',
    'Fire', 'Lightning', 'Quantum', 'Imaginary']
Adjustment_Coefficient = [0.85, 1.00, 1.30, 1, 1]
YiQi_Unit = {
              'SPD': 10000,
              'crit_rate': 3240,
              'crit_damage': 6480,
              'break_effect': 6480,
              'effect_hit_rate': 4320,
              'effect_RES': 4320,
              'HP': 42337.55,
              'ATK': 21168.77,
              'DEF': 21168.77,
              'HP%': 4320,
              'ATK%': 4320,
              'DEF%': 5400
}
YiQi_Unit_BASE = {
              'SPD': 10000,
              'crit_rate': 648,
              'crit_damage': 1296,
              'break_effect': 1296,
              'effect_hit_rate': 864,
              'effect_RES': 864,
              'HP': 8467.51,
              'ATK': 4233.75,
              'DEF': 4233.75,
              'HP%': 864,
              'ATK%': 864,
              'DEF%': 1080
}
class Level_Const:
    def __init__(self):
        self.label = ['ATK', 'DEF', 'HP', 'SPD']
        self.Enemy_Const = np.array([['0.640000 ', ' 1.000000 ', ' 0.800000 ', ' 1.00'],
                                     ['0.766887 ', ' 1.047619 ',
                                         ' 1.050000 ', ' 1.00'],
                                     ['0.814786 ', ' 1.095238 ',
                                         ' 1.100000 ', ' 1.00'],
                                     ['1.125528 ', ' 1.142857 ',
                                         ' 1.362518 ', ' 1.00'],
                                     ['1.181478 ', ' 1.190476 ',
                                         ' 1.428762 ', ' 1.00'],
                                     ['1.238469 ', ' 1.238095 ',
                                         ' 1.496191 ', ' 1.00'],
                                     ['1.296802 ', ' 1.285714 ',
                                         ' 1.564808 ', ' 1.00'],
                                     ['1.373344 ', ' 1.333333 ',
                                         ' 1.634615 ', ' 1.00'],
                                     ['1.416696 ', ' 1.380952 ',
                                         ' 1.705617 ', ' 1.00'],
                                     ['1.460110 ', ' 1.428571 ',
                                         ' 1.777814 ', ' 1.00'],
                                     ['1.608240 ', ' 1.476190 ',
                                         ' 1.902566 ', ' 1.00'],
                                     ['1.756371 ', ' 1.523810 ',
                                         ' 2.027318 ', ' 1.00'],
                                     ['1.904501 ', ' 1.571429 ',
                                         ' 2.152070 ', ' 1.00'],
                                     ['2.052631 ', ' 1.619048 ',
                                         ' 2.276821 ', ' 1.00'],
                                     ['2.200761 ', ' 1.666667 ',
                                         ' 2.401573 ', ' 1.00'],
                                     ['2.348891 ', ' 1.714286 ',
                                         ' 2.526325 ', ' 1.00'],
                                     ['2.497022 ', ' 1.761905 ',
                                         ' 2.651077 ', ' 1.00'],
                                     ['2.645152 ', ' 1.809524 ',
                                         ' 2.775828 ', ' 1.00'],
                                     ['2.793282 ', ' 1.857143 ',
                                         ' 2.900580 ', ' 1.00'],
                                     ['2.941412 ', ' 1.904762 ',
                                         ' 3.025332 ', ' 1.00'],
                                     ['3.191520 ', ' 1.952381 ',
                                         ' 3.247060 ', ' 1.00'],
                                     ['3.441627 ', ' 2.000000 ',
                                         ' 3.468788 ', ' 1.00'],
                                     ['3.691735 ', ' 2.047619 ',
                                         ' 3.690516 ', ' 1.00'],
                                     ['3.941842 ', ' 2.095238 ',
                                         ' 3.912244 ', ' 1.00'],
                                     ['4.191950 ', ' 2.142857 ',
                                         ' 4.133972 ', ' 1.00'],
                                     ['4.442057 ', ' 2.190476 ',
                                         ' 4.355701 ', ' 1.00'],
                                     ['4.692165 ', ' 2.238095 ',
                                         ' 4.577429 ', ' 1.00'],
                                     ['4.942272 ', ' 2.285714 ',
                                         ' 4.799157 ', ' 1.00'],
                                     ['5.192380 ', ' 2.333333 ',
                                         ' 5.020885 ', ' 1.00'],
                                     ['5.442487 ', ' 2.380952 ',
                                         ' 5.242613 ', ' 1.00'],
                                     ['5.761692 ', ' 2.428571 ',
                                         ' 5.670810 ', ' 1.00'],
                                     ['6.080898 ', ' 2.476190 ',
                                         ' 6.099006 ', ' 1.00'],
                                     ['6.400103 ', ' 2.523810 ',
                                         ' 6.527203 ', ' 1.00'],
                                     ['6.719308 ', ' 2.571429 ',
                                         ' 6.955400 ', ' 1.00'],
                                     ['7.038513 ', ' 2.619048 ',
                                         ' 7.383597', '1.00'],
                                     ['7.357718 ', ' 2.666667 ',
                                         ' 7.811794 ', ' 1.00'],
                                     ['7.676923 ', ' 2.714286 ',
                                         ' 8.239990 ', ' 1.00'],
                                     ['7.996129 ', ' 2.761905 ',
                                         ' 8.668187 ', ' 1.00'],
                                     ['8.315334 ', ' 2.809524 ',
                                         ' 9.096384 ', '1.00'],
                                     ['8.634539 ', ' 2.857143 ',
                                         ' 9.524581 ', '1.00'],
                                     ['9.071262 ', ' 2.904762 ',
                                         ' 10.786134 ', ' 1.00'],
                                     ['9.507986 ', ' 2.952381 ',
                                         ' 12.047688 ', ' 1.00'],
                                     ['9.944709 ', ' 3.000000 ',
                                         ' 13.309242 ', ' 1.00'],
                                     ['10.381433 ', ' 3.047619 ',
                                         ' 14.570795 ', ' 1.00'],
                                     ['10.818156 ', ' 3.095238 ',
                                         ' 15.832349 ', ' 1.00'],
                                     ['11.254880 ', ' 3.142857 ',
                                         ' 17.093903 ', ' 1.00'],
                                     ['11.691603 ', ' 3.190476 ',
                                         ' 18.355456 ', ' 1.00'],
                                     ['12.128327 ', ' 3.238095 ',
                                         ' 19.617010 ', ' 1.00'],
                                     ['12.565050 ', ' 3.285714 ',
                                         ' 20.878564 ', ' 1.00'],
                                     ['13.001774 ', ' 3.333333 ',
                                         ' 22.140117 ', ' 1.00'],
                                     ['13.581057 ', ' 3.380952 ',
                                         ' 25.198520 ', ' 1.00'],
                                     ['14.160340 ', ' 3.428571 ',
                                         ' 28.256923 ', ' 1.00'],
                                     ['14.739623 ', ' 3.476190 ',
                                         ' 31.315326 ', ' 1.00'],
                                     ['15.318906 ', ' 3.523810 ',
                                         ' 34.373729 ', ' 1.00'],
                                     ['15.898189 ', ' 3.571429 ',
                                         ' 37.432132 ', ' 1.00'],
                                     ['16.477472 ', ' 3.619048 ',
                                         ' 40.490535 ', ' 1.00'],
                                     ['17.056735 ', ' 3.666667 ',
                                         ' 43.548938 ', ' 1.00'],
                                     ['17.636038 ', ' 3.714286 ',
                                         ' 46.607341 ', ' 1.00'],
                                     ['18.215321 ', ' 3.761905 ',
                                         ' 49.665744 ', ' 1.00'],
                                     ['18.794605 ', ' 3.809524 ',
                                         ' 52.724147 ', ' 1.00'],
                                     ['19.336283 ', ' 3.857143 ',
                                         ' 56.950449 ', ' 1.00'],
                                     ['19.877961 ', ' 3.904762 ',
                                         ' 61.176751 ', ' 1.00'],
                                     ['20.419640 ', ' 3.952381 ',
                                         ' 65.403053 ', ' 1.00'],
                                     ['20.961318 ', ' 4.000000 ',
                                         ' 69.629355 ', ' 1.00'],
                                     ['21.502996 ', ' 4.047619 ',
                                         ' 73.855657 ', ' 1.10'],
                                     ['22.044675 ', ' 4.095238 ',
                                         ' 78.081959 ', ' 1.10'],
                                     ['22.586353 ', ' 4.142857 ',
                                         ' 82.308261 ', ' 1.10'],
                                     ['23.128032', '4.190476',
                                         '86.534563', '1.10'],
                                     ['23.669710', '4.238095',
                                         '90.760865', '1.10'],
                                     ['24.211388', '4.285714',
                                         '94.987167', '1.10'],
                                     ['24.858698', '4.333333',
                                         '100.289552', '1.10'],
                                     ['25.506008', '4.380952',
                                         '105.591938', '1.10'],
                                     ['26.153318', '4.428571',
                                         '110.894324', '1.10'],
                                     ['26.800628', '4.476190',
                                         '116.196710', '1.10'],
                                     ['27.447938', '4.523810',
                                         '121.499095', '1.10'],
                                     ['28.095248', '4.571429',
                                         '126.801481', '1.10'],
                                     ['28.742558', '4.619048',
                                         '132.103867', '1.10'],
                                     ['29.389868', '4.666667',
                                         '137.406253', '1.20'],
                                     ['30.037178', '4.714286',
                                         '142.708639', '1.20'],
                                     ['30.684488', '4.761905',
                                         '148.011024', '1.20'],
                                     ['31.298178', '4.809524',
                                         '155.487432', '1.20'],
                                     ['31.911868', '4.857143',
                                         '163.240467', '1.20'],
                                     ['32.525558', '4.904762',
                                         '171.280364', '1.20'],
                                     ['33.139247', '4.952381',
                                         '179.617738', '1.20'],
                                     ['33.752937', '5.000000',
                                         '188.263594', '1.20'],
                                     ['34.366627', '5.047619',
                                         '197.229347', '1.32'],
                                     ['34.980317', '5.095238',
                                         '206.526833', '1.32'],
                                     ['35.594006', '5.142857',
                                         '216.168326', '1.32'],
                                     ['36.207696', '5.190476',
                                         '226.166554', '1.32'],
                                     ['36.821386', '5.238095',
                                         '236.534716', '1.32'],
                                     ['37.435076', '5.285714',
                                         '247.286501', '1.32'],
                                     ['38.048765', '5.333333',
                                         '258.436102', '1.32'],
                                     ['38.662455', '5.380952',
                                         '269.998237', '1.32'],
                                     ['39.276145', '5.428571',
                                         '281.988172', '1.32'],
                                     ['39.889835', '5.476190',
                                         '294.421734', '1.32'],
                                     ['40.503525', '5.523810',
                                         '307.315339', '1.32'],
                                     ['41.117214', '5.571429',
                                         '320.686006', '1.32'],
                                     ['41.730904', '5.619048',
                                         '334.551388', '1.32'],
                                     ['42.344594', '5.666667',
                                         '348.929790', '1.32'],
                                     ['42.958284', '5.714286', '363.840192', '1.32']], dtype=float)
        character_and_light_core_const = []
        c, l = 100, 100
        for i in range(80):
            if i in [20, 30, 40, 50, 60, 70]:
                c += 40
            if i == 20:
                l += 120
            elif i in [30, 40, 50, 60, 70]:
                l += 160
            character_and_light_core_const.append([c, l])
            c += 5
            l += 15
        self.ch_lc = character_and_light_core_const

    def get_enemy(self, level, label=None):
        if label is None:
            return self.Enemy_Const[level - 1]
        return self.Enemy_Const[level - 1][self.label.index(label)]

    def get_ch(self, level):
        return self.ch_lc[level - 1][0] / 100

    def get_lc(self, level):
        return self.ch_lc[level - 1][1] / 100

    def __sizeof__(self):
        return self.Enemy_Const

    def __len__(self):
        return len(self.Enemy_Const)
